module my_own_little_code_utilities
use my_own_da
use my_analysis
integer, parameter :: nmul=3
logical ::  pseudo_radiation=.false.
real(dp) :: crad=1.e-4_dp,cfluc=1.e-5_dp  !@ not used yet

  INTERFACE CANONIZE
     MODULE PROCEDURE CANONIZE_ray   !@1 &nbsp; Puts the ray into a special form
  END INTERFACE

type ray
 type(my_taylor) z(2)
 real(dp) stochastic_envelope(2,2) !@  &nbsp; not used yet
end type ray 

type magnet
 real(dp) L
 real(dp) bn(0:nmul),h 
 integer n
 character(8) name
end type magnet

contains 

  subroutine CANONIZE_ray( z,PHASE_ADVANCE, a_cs )
    implicit none
    TYPE (MY_TAYLOR) , INTENT (inout) ::   z(2)
    TYPE(MY_TAYLOR), INTENT (inout) ::  PHASE_ADVANCE
    TYPE(my_map), INTENT (inout) ::  a_cs
    TYPE (my_map) a,r
    
    a=z
     call CANONIZE( A,A_cs,R,PHASE_ADVANCE )
    z=a_cs 
  
  end subroutine CANONIZE_ray

  subroutine track_magnet( r,mag )
    implicit none
    TYPE (MY_TAYLOR) z(2),rad
    TYPE (ray) , INTENT (inout) ::   r
    TYPE (magnet) , INTENT (in) ::   mag
    integer n,i,j
    real(dp) dl,fac
    z=r%z
    if(mag%l/=0) then  
     dl=mag%L/mag%n  
    do i=1,mag%n
     z(1)=z(1)+DL/2.d0*z(2)
     fac=1.0_dp
     do j=0,nmul
      z(2)=z(2)-mag%bn(j)*dl*z(1)**(j)/fac
       fac=fac*(j+1)
     enddo
! Ideal sector bend focussing and removal of design orbit  b(0)=h
      z(2)=z(2)-mag%bn(0)*mag%h*dl*z(1)+mag%h*dl
! End of sector adjustments
! fake radiation
   if(pseudo_radiation)  then
     rad=0.0_dp
     fac=1.0_dp
     do j=0,nmul
      rad=rad+(mag%bn(j)*z(1)**(j)/fac)**2
       fac=fac*(j+1)
     enddo
     z(1)=z(1)-dl*crad*rad*z(1)
   endif
!End fake radiation
     z(1)=z(1)+DL/2.d0*z(2)
    enddo
   else
     fac=1.0_dp
     do j=0,nmul
      z(2)=z(2)-mag%bn(j)*z(1)**(j)/fac
      fac=fac*(j+1)
    enddo    
   endif
   
   r%z=z
   
  end subroutine track_magnet
  
  
    subroutine track_lattice( r,L,loc1, loc2)
    implicit none
    TYPE (magnet) , INTENT (in) ::   L(:)
    TYPE (ray) , INTENT (inout) ::  r
    integer n,loc1, loc2,i
    

    n=size(L)
    if(loc1> n) stop 1
    if(loc2> n) stop 2
    
    if(loc2>loc1) then
     do i=loc1,loc2-1
      call track_magnet( r,L(i) )
     enddo
    elseif(loc1>=loc2) then
     do i=loc2,n
      call track_magnet( r,L(i) )
     enddo
     do i=1,loc1-1
      call track_magnet( r,L(i) )
     enddo
    endif         
    end subroutine track_lattice
  
    subroutine find_closed_orbit( fix,L,loc)
    implicit none
    real(dp) fix(2),dfix(2)
    TYPE (magnet) , INTENT (in) ::   L(:)
    type(my_map) m,id
    type(ray) r
    integer loc,i,my_old_taylor
    real(dp) dnorm1,dnorm2
    
    id=1
    fix=0.0_dp
    my_old_taylor=my_order
    my_order=1
    dnorm1=-1
    
    
    
    do i=1,100
       m=1
       r%z=fix+m
        
       call track_lattice(r,L,loc,loc)
       
       
       m=r%z
       
       m%v(1)=m%v(1)-id%v(1)-fix(1)
       m%v(2)=m%v(2)-id%v(2)-fix(2)
       m=m.oo.(-1)
       dfix=m
       fix=fix+dfix
        dnorm2=abs(dfix(1))+abs(dfix(2))
       if(i>10) then
        if(dnorm2>=dnorm1) exit
       endif
        dnorm1=dnorm2
    enddo
     if(i>99) write(6,*) " Find_closed_orbit did not converged "
    
    my_order=my_old_taylor

    end subroutine find_closed_orbit
end module my_own_little_code_utilities

